var ui={
		
		//How many records to retrieve in paginated queries
		defaultPageSize:25,
		
		daysOfWeek:["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"],
		monthsOfYear:["January","February","March","April","May","June","July","August","September","October","November","December"],

		errorMessageBar:function(msg, parent){
			return ui._messageBar(msg,'errorbar',parent);
		},
		warningMessageBar:function(msg, parent){
			return ui._messageBar(msg,'warningbar',parent);
		},
		infoMessageBar:function(msg, parent){
			return ui._messageBar(msg,'infobar',parent);
		},
		_messageBar:function(msg,cssClass,parent){
			var bar=document.createElement("div");
			bar.className="msgbar "+cssClass;
			bar.innerHTML=msg;
			if(null!=parent){ parent.appendChild(bar); }
			return bar;
		},
		
		/**
		 * Renders a box inside the parent element. If parent is not specified, it will default to $("grid"), then $("content");
		 * @param box An object containing some of the following keys:
		 * - id The box ID
		 * - classes A space-separated list of CSS classes to apply to the box
		 * - title The box title. If not present, the box will have no header
		 * - content HTML for the box body. Should not be used with "url" option
		 * - url The API url to fetch content for the box
		 * - pageSize How many records to fetch at a time, default is ui.defaultPageSize
		 * @param parent The parent element
		 */
		box:function(box, parent){
			var b=document.createElement("div").addClassName("box");
			var boxid='box'+Math.floor(1000000*Math.random());
			if(box.id){ boxid=box.id; }
			b.id=boxid;
			if(box.classes){ b.addClassName(box.classes); }
			if(box.title){ 
				var h2=document.createElement("h2");
				h2.innerHTML=box.title;
				b.appendChild(h2);
			} else {
				b.addClassName("noheader");
			}
			var bb=document.createElement("div").addClassName("boxbody")
			b.appendChild(bb);
			var content='';
			if(box.url){
				bb.dataset.apiurl=box.url;
				bb.dataset.pagesize=box.pageSize || ui.defaultPageSize;
				bb.dataset.pagenumber=1;
				content='Loading...';
			} else if(box.content){
				content=box.content;
			}
			bb.innerHTML=content;
			b.table=function(tbl,data){ return ui.table(tbl,data,boxid); }
			b.form=function(frm){ return ui.form(frm,b); }
			b.treeItem=function(item){ return ui.treeItem(item,b); }
			bb.table=function(tbl,data){ return ui.table(tbl,data,boxid); }
			bb.form=function(frm){ return ui.form(frm,b); }
			bb.treeItem=function(item){ return ui.treeItem(item,b); }
			if(null!=parent){ $(parent).appendChild(b);}
			if(box.url){
				var successHandler=function(transport){
					b.table({ headers:box.headers, cellTemplates:box.cellTemplates }, transport.responseJSON);
				}
				if(box.successHandler){ successHandler=box.successHandler; }
				if(box.url.indexOf("?")>1){
					box.url+="&";
				} else {
					box.url+="?";
				}
				box.url+="pagenumber=1&pagesize="+bb.dataset.pagesize;
				new Ajax.Request(box.url,{
						method:'get',
						onSuccess:function(transport){ successHandler(transport, b)},
						onFailure:function(transport){ ui.defaultFailureHandler(transport, b)}
				});
			}
			return $(bb);
		},
		
		/**
		 * Open a modal box with the specified title and content. If needed, a function to call on close can be specified.
		 * 
		 * Parameters: As for ui.box (title and content are most interesting here), plus optionally confirmClose or onclose.
		 * 
		 * title: The title of the box
		 * content: The content of the box
		 * confirmClose: if $("modalBox").tainted===true at close, call ui.confirmCloseModalBox on close. The onclose option overrides this.
		 * onclose: A custom function called when the box is closed. It should return true if the box can be close, false otherwise. Overrides confirmClose.
		 */
		modalBox:function(box){
			if(!$("modalWindow")){
				document.body.innerHTML+='<div id="modalWindow"><div id="modalBackground"></div><div id="modalContent" onclick="ui.closeModalBox()"></div></div>';
			}
			if($('modalBox')){ $('modalBox').remove(); }
			if($('modalTabSet')){ $('modalTabSet').remove(); }
			box.id="modalBox";
			var mbox=ui.box(box,'modalContent');
			$("modalBox").down("h2").innerHTML='<span>'+$("modalBox").down("h2").innerHTML+'</span>';
			$("modalBox").down("h2").insert({ top:'<img id="modalboxclose" onclick="ui.closeModalBox()" style="cursor: pointer; height:2em; position:absolute; right:0.25em; top:0;" src="/images/icons/'+theme+'theme/close.gif" /></div>' });
			$("modalWindow").style.display="block";
			if(box.onclose){ 
				$("modalBox").closeCallback=box.onclose; 
			} else if(box.confirmClose){
				$("modalBox").closeCallback=ui.confirmCloseModalBox; 
			}
			$("modalBox").tainted=false;
			document.observe("keyup",ui.checkForCloseModalBoxEscapeKey);
			return mbox;
		},
		
		setModalBoxTitle:function(title){
			if(!$('modalBox')){ return; }
			$('modalBox').down("h2 span").innerHTML=title;
		},
		
		modalTabSet:function(){
			if(!$("modalWindow")){
				document.body.innerHTML+='<div id="modalWindow"><div id="modalBackground" onclick="ui.closeModalBox()"></div><div id="modalContent" onclick="ui.closeModalBox()"></div></div>';
			}
			if($('modalBox')){ $('modalBox').remove(); }
			if($('modalTabSet')){ $('modalTabSet').remove(); }
			$("modalWindow").style.display="block";
			document.observe("keyup",ui.checkForCloseModalBoxEscapeKey);
			var ts=ui.tabSet({ id:'modalTabSet' }, $('modalContent'));
			var t =document.createElement("h2").addClassName("tab close");
			t.innerHTML='Close';
			t.onclick=ui.closeModalBox;
			ts.appendChild(t);
			return ts;
		},
		
		checkForCloseModalBoxEscapeKey:function(evt){
			if(27==evt.keyCode){ ui.closeModalBox(); }
		},
		
		/**
		 * Closes a modal box. If onclose or confirmClose was specified and returns false, the box will not close.
		 */
		closeModalBox:function(){
			if($("modalBox")){ 
				if($("modalBox").closeCallback && !$("modalBox").closeCallback()){ return false; }
				$("modalBox").remove();
			} else if($("modalTabSet")){
				$("modalTabSet").remove();
			}
			$("modalWindow").style.display="none";
			document.stopObserving("keyup",ui.checkForCloseModalBoxEscapeKey);
		},
		
		/**
		 * Default "confirm close" function for modal box. Returns true if $("modalBox").tainted evaluates to false or the user confirms close.
		 * Specify this behaviour with confirmClose:true in the original call to ui.modalBox().
		 */
		confirmCloseModalBox:function(){
			if(false===$("modalBox").tainted){ return true; }
			return confirm("Really close this box?");
		},
		

		tabSet:function(tabSet, parent){
			var ts=document.createElement("div").addClassName("tabset");
			if(tabSet.id){ ts.id=tabSet.id; }
			if(tabSet.classes){ ts.addClassName(tabSet.classes); }
			if(null!=parent){ parent.appendChild(ts);}
			ts.tab=function(tab){ return ui.tab(tab,ts); }
			ts.filesTab=function(relatedObjectIds){ return ui.filesTab(ts,relatedObjectIds); }
			ts.notesTab=function(){ return ui.notesTab(ts); }
			ts.startTab=document.location.hash.substr(1);
			return ts;
		},
		
		tab:function(tab,parent){
			var t =document.createElement("h2");
			if(tab.classes){ t.className=tab.classes; }
			t.addClassName("tab");
			t.innerHTML=tab.label;
			t.observe("click", ui.clickTab);
			if(tab.callback){  t.observe("click", tab.callback); }
			var tb=document.createElement("div");
			$(tb).addClassName("tabbody");
			var content='';
			if(tab.url){
				content='Loading...';
				tb.dataset.apiurl=tab.url;
				tb.dataset.pagesize=tab.pageSize || ui.defaultPageSize;
				tb.dataset.pagenumber=1;
			} else if(tab.renderer){
				content='Loading...';
				tb.dataset.apiurl=tab.url;
				tb.dataset.pagesize=tab.pageSize || ui.defaultPageSize;
				tb.dataset.pagenumber=1;
				tb.renderer=tab.renderer;
			} else if(tab.content){
				content=tab.content;
			}
			tb.innerHTML=content;
			if(tab.id){ 
				t.id=tab.id;
				tb.id=tab.id+"_body";
			}
			if(null!=parent){ 
				parent.appendChild(t);
				parent.appendChild(tb);
				var tabs=parent.select(".tab");
				if(1==tabs.length || t.id==parent.startTab){ t.click(); }
			}
			t.table=function(tbl,data){ return ui.table(tbl,data,tb); }
			t.form=function(frm){ return ui.form(frm,tb); }
			t.treeItem=function(item){ return ui.treeItem(item,tb); }
			t.refresh=function(){ return ui.refreshTab(tb); }
			tb.table=function(tbl,data){ return ui.table(tbl,data,tb); }
			tb.form=function(frm){ return ui.form(frm,tb); }
			tb.treeItem=function(item){ return ui.treeItem(item,tb); }
			tb.refresh=function(){ return ui.refreshTab(tb); }
			
			if(tb.renderer){
				tb.renderer(tb);
			} else if(tab.url){
				tb.successHandler=function(transport){
					t.table({ headers:tab.headers, cellTemplates:tab.cellTemplates, contentBefore:tab.contentBefore }, transport.responseJSON);
				}
				if(tab.successHandler){ tb.successHandler=tab.successHandler; }
				tb.failureHandler=function(transport){ ui.defaultFailureHandler(transport, tb)}
				if(tab.failureHandler){ tb.failureHandler=tab.failureHandler; }
				if(tab.url.indexOf("?")>0){
					tab.url+="&";
				} else {
					tab.url+="?";
				}
				tab.url+="pagenumber=1&pagesize="+tb.dataset.pagesize;
				tb.url=tab.url;
				ui.refreshTab(t);
			}
			return t;
		},

		refreshTab:function(tab){
			tab=$(tab);
			if(!tab.hasClassName("tabbody")){
				if(tab.next().hasClassName("tabbody")){
					tab=tab.next();
				}
				if(!tab.hasClassName("tabbody")){
					alert("refreshTab called on something that was not a tab");
					return false;
				}
			}
			if(tab.renderer){
				tab.innerHTML="Loading...";
				tab.renderer();
			} else if(tab.url){
				tab.innerHTML="Loading...";
				new Ajax.Request(tab.url,{
					method:'get',
					onSuccess:function(transport){ tab.successHandler(transport, tab)},
					onFailure:function(transport){ tab.failureHandler(transport, tab)}
				});
			} else {
				return false;
			}
		},
		
		clickTab:function(evt){
			var t=evt.target;
			var ts=t.up(".tabset");
			var tabs=ts.select(".tab");
			tabs.each(function(tab){ 
				tab.removeClassName("current");
			});
			t.addClassName("current");
			window.document.location.hash=t.id;
		},
		
		filesTab: function(ts, relatedObjectIds){
			if(!data.projectname || 'Default Project'==data.projectname){ 
				ts.tab({
					'id':'files',
					'label':'Files',
					'content':'Set the protein first',
				});
				return false; 
			}
			ui.fileTabHeaders=['File','Description','Size'];
			ui.fileTabTemplates=[ '<a class="filelink" target="_blank" href="/api/file/{{id}}/{{filename}}">{{filename}}</a>','{{description}}','{{bytes}}'];
			var afterFilesTab=function(){
				if(!canEdit){
					if(!$("files_body").down("a.filelink")){
						$("files_body").down("table").innerHTML+='<tr><td colspan="'+ui.fileTabHeaders.length+'">No files</td></tr>';
					}
					return;
				}
				$("files_body").down("table").innerHTML+='<tr>'+
					'<td><input type="file" name="file"></td>'+
					'<td><input type="text" name="description" placeholder="Description"></td>'+
					'<td><input type="button" name="addfile" id="addfile" value="Add file" onclick="if(0!=this.up(\'form\').down(\'[type=file]\').files.length){ ui.submitForm(this) }"></td>'+
					'</tr>';
				$("files_body").insert({ bottom:'<form class="noprint" action="/api/file" id="files_form" method="post" enctype="multipart/formdata" onsubmit="return false;">'+
						'<input type="hidden" name="csrfToken" value="'+csrfToken+'" />'+
						'<input type="hidden" name="parentid" value="'+data.id+'" />'+
					'</form>'
				});
				$("addfile").options={
					afterSuccess:function(responseJSON){
						$("files_body").refresh();
					}
				}
				$("files_form").insert({ bottom:$("files_body").down("table").remove() });
				
				/*
				 * Get files for any related object IDs that were passed in
				 */
				var relatedIds=$("files").relatedObjectIds;
				if(!relatedIds){ relatedIds=[]; }
				relatedIds=[0].concat(relatedIds);
				for(i=0;i<relatedIds.length;i++){
					relatedId=relatedIds[i];
					if(0==1*relatedId){ continue; }
					new Ajax.Request('/api/baseobject/'+(1*relatedId)+'/file', {
						method:'get',
						onSuccess:function(transport){
							transport.responseJSON.rows.each(function(f){
								if(""==f.name && ""!=f.filename){ f.name=f.filename; }
								var row='<tr><td>'+ui.fileTabTemplates.join('</td><td>')+'</td></tr>';
								row=row.replace("{{id}}",f.id);
								row=row.replace("{{filename}}",f.filename,'g'); // in href
								row=row.replace("{{filename}}",f.filename,'g'); // in sight
								row=row.replace("{{description}}",f.description);
								row=row.replace("{{bytes}}",f.bytes);
								$("files_body").down("tr").insert({ after:row });
							});
						},
						onFailure:function(transport){
							return;
						}
					});
				}

			}
			var t=ts.tab({
				'id':'files',
				'label':'Files',
				'url':'/api/baseobject/'+data.id+'/file',
				'pageSize':10000,
				'headers':ui.fileTabHeaders,
				'cellTemplates':ui.fileTabTemplates,
				'successHandler':function(transport){
					$("files_body").table({ headers:ui.fileTabHeaders, cellTemplates:ui.fileTabTemplates }, transport.responseJSON);
					afterFilesTab();
				},
				'failureHandler':function(){
					//Failure is almost certainly "No files" so just render an empty table
					var tr=document.createElement("tr");
					tr.innerHTML="<th>"+ui.fileTabHeaders.join("</th><th>")+"</th>";
					var tbl=document.createElement("table");
					tbl.appendChild(tr);
					$("files_body").addClassName("hastable");
					$("files_body").innerHTML="";
					$("files_body").appendChild(tbl);
					afterFilesTab();
				}
			});
			t.relatedObjectIds=relatedObjectIds;
			return t;
		},
		
		noteFormTemplate:'<form id="notesform" class="noprint">'+
				'<input type="hidden" name="parentid" value=""/>'+
				'<input type="hidden" name="csrfToken" value=""/>'+
				'<label style="position:relative;top:0;padding:0.25em 0.5em;margin-bottom:0.5em"><textarea style="width:100%;height:5em" name="text" id="text" placeholder="Add a note..."></textarea><input type="button" onclick="ui.addNote(this)" value="Add note"/><div style="clear:both"></div></label></form>',
		noteTemplate:'<a href="/user/{{userid}}">{{username}}</a>, {{createtime}}:<br/><div style="line-height:1.25em;margin-bottom:0.5em">{{text}}</div>',
		notesTab:function(ts){
			if(!data.projectname || 'Default Project'==data.projectname){ 
				ts.tab({
					'id':'notes',
					'label':'Notes',
					'content':'This item is in the default project, so notes cannot be added. If you have permission to do so, you should move it to a real working project.',
				});
				return false; 
			}
			var t=ts.tab({
				'id':'notes',
				'label':'Notes',
				'url':'/api/baseobject/'+data.id+'/note',
				'pageSize':100000,
				'cellTemplates':[ [ui.processNoteTemplate,'id'] ],
				'contentBefore': canEdit ? ui.noteFormTemplate : '',
				'failureHandler':function(){ t.next().innerHTML=canEdit ? ui.noteFormTemplate : 'No notes'; }
			});
			return t;
		},
		processNoteTemplate: function(note, key){
			var t=""+ui.noteTemplate;
			t=t.replace("{{createtime}}", ui.friendlyDate(note.createtime) );
			note.text=note.text.replace(/(http[s]?:[^\s]+)/g,'<a href="$&">$&</a>');
			note.text=note.text.replace(/(?:\r\n|\r|\n)/g,"<br/>");
			var regex=/{{[()\.a-zA-Z0-9_-]+}}/g;
			var found=t.match(regex);
			if(found){
				found.each(function(f){
					var prop=f.slice(2,-2);
					t=t.replace(f,note[prop]);
				});
			}
			return t +"";
		},
		addNote: function(btn){
			btn.up("label").addClassName("updating");
			btn.options={
				afterSuccess:function(){
					$("notes_body").refresh();
				}
			};
			$("notesform").action='/api/note';
			$("notesform").method='post';
			$("notesform").down('[name=parentid]').value=data.id;
			$("notesform").down('[name=csrfToken]').value=csrfToken;
			ui.submitForm(btn);
		},
		
		/**
		 * Writes a table template into the parent element and populates it with the supplied data.
		 * @param tbl An object describing the table, with some of the following properties:
		 * - contentBefore HTML to insert at the top of the table
		 * - headers An array of column headers (required)
		 * - cellTemplates An array of templates for each cell in a row (required). A function can be passed, see below.
		 * Passing functions into cell templates: Pass an array of function name and (optionally) the property, for example [ui.checkmark, 'isactive']. When
		 * defining custom functions for use in this way, the function should take the data row and (optionally) the field name as arguments. It should return the HTML to insert into the table cell.
		 * @param data The JSON data to be rendered
		 * @param parent The parent element of the new table
		 * @return the table element
		 */
		table:function(tbl,data,parent){
			parent=$(parent);
			if(parent.down(".boxbody")){ parent=parent.down(".boxbody"); }
			if(parent.hasClassName("tab")){ parent=parent.next(".tabbody"); }
			//TODO check all template arrays same length
			var t=document.createElement("table");
			if(tbl.id){
				t.id=tbl.id; 
			} else if(null!=parent){
				t.id=parent.id+"_table";
			} else {
				t.id="table"+Math.floor(1000000*Math.random());
			}
			t.className="uitable";
			t.cellTemplates=tbl.cellTemplates;
			t.hasNoMore=false;
			
			if(tbl.contentBefore){
				var rowBefore=document.createElement("tr");
				rowBefore.className="beforetable headerrow";
				var tdBefore=document.createElement("td");
				tdBefore.colSpan=tbl.cellTemplates.length;
				if(tbl.headers){ tdBefore.colSpan=tbl.headers.length; }
				tdBefore.innerHTML=tbl.contentBefore;
				rowBefore.appendChild(tdBefore);
				t.appendChild(rowBefore);
			}

			if(null!=tbl.headers && 0!=tbl.headers.length){
				var tr=document.createElement("tr");
				tr.className="headerrow";
				tbl.headers.each(function(h){
					var th=document.createElement("th");
					th.innerHTML=h;
					tr.appendChild(th);
				});
				t.appendChild(tr);
			}
			var moreTr=document.createElement("tr");
			moreTr.className="listmore noprint";
			moreTr.id=t.id+"_more";
			var moreTd=document.createElement("td");
			moreTd.colSpan=t.cellTemplates.length;
			if(ui.isSmallScreen){
				moreTd.innerHTML='<a href="#" onclick="ui.lazyLoad(this.up(\'table\'));return false">See more</a>';
			} else {
				moreTd.innerHTML="Loading...";
			}
			moreTr.appendChild(moreTd);
			t.appendChild(moreTr);
			
			if(null!=parent){
				parent.innerHTML="";
				parent.appendChild(t);
				parent.addClassName("hastable");
			}
			
			if(data.rows){
				ui.renderTableRows(t, data.rows);
			} else if(data.data) {
				ui.renderTableRows(t, data.data);
			}
			
			if(null!=parent && data.rows.length>=parent.dataset.pagesize){
				if(ui.isSmallScreen){
					
				} else {
					window[parent.id+"_lazyload"]=function(){ ui.lazyLoad(t) };
					window.setInterval(window[parent.id+"_lazyload"], 1000);
				}
			}
			t.updating=false;
			return t;
		},

		/**
		 * Adds the specified items to an existing table as table rows, using the table's row templates.
		 * @param tbl The table
		 * @param items The items to add.
		 */
		renderTableRows:function(tbl, items){
			var loadRow=$(tbl).down("tr.listmore");
			var regex=/{{[()\.a-zA-Z0-9_-]+}}/g;
			var container=tbl.up();
			items.each(function(row){
				if("object"!=(typeof row).toLowerCase()){ return; } //continue to next row
				var cells=new Array();
				tbl.cellTemplates.each(function(ct){
					if(ct instanceof Array && 2==ct.length){
						if(typeof(ct[0])!=='function'){
							cells.push('[Array]');
						} else {
							//call the function, with object and property name as args
							cells.push( ct[0](row, ct[1]) )
							//cells.push( typeof(ct[0])+typeof(row)+typeof(ct[1]) )
						}
					} else {
						cells.push(ct.trim());
					}
				});
				tr=document.createElement("tr");
				tr.className="datarow";
				cells.each(function(c){
					var td=document.createElement("td");
					var found=c.match(regex);
					if(found){
						found.each(function(f){
							var prop=f.slice(2,-2);
							c=c.replace(f,row[prop]);
						});
					}
					td.innerHTML=c;
					tr.appendChild(td);
				});
				tr.rowData=row;
				loadRow.insert({before:tr});
			});
			if(!container.dataset || !container.dataset.pagesize || items.length<container.dataset.pagesize){
				//there won't be another page, so
				tbl.hasNoMore=true;
				loadRow.remove();
			}
			tbl.updating=false;
		},

		lazyLoad:function(tbl){
			var pixelBuffer=100; //start lazy load when "loading" row is this many pixels below bottom edge of container
			if(!$(tbl.id) || !tbl.up() || tbl.updating || tbl.hasNoMore || !tbl.down("tr.listmore")){ return false; }
			if(tbl.up(".tabbody") && !tbl.up(".tabbody").previous().hasClassName("current")){ 
				//Table is in a tab but tab is not current, so...
				return false; 
			}
			if(tbl.down("tr.listmore").viewportOffset().top-pixelBuffer>(tbl.up().viewportOffset().top+tbl.up().getHeight())){
				//loading row not visible, so...
				return false;
			}
			tbl.updating=true;
			var container=tbl.up();

			container.dataset.pagenumber=(1*container.dataset.pagenumber)+1;
			var pageNumber=1*container.dataset.pagenumber;
			var pageSize=1*container.dataset.pagesize;
			var url=container.dataset.apiurl;
			if(url.indexOf("?")>0){
				url+="&";
			} else {
				url+="?";
			}
			url+="pagesize="+pageSize+"&pagenumber="+pageNumber;
			new Ajax.Request(url,{
				method:"get",
				onSuccess:function(transport){ ui.lazyLoad_onSuccess(tbl,transport); },
				onFailure:function(transport){ ui.lazyLoad_onFailure(tbl,transport); },
			});
		},
		lazyLoad_onSuccess:function(tbl,transport){
			ui.renderTableRows(tbl, transport.responseJSON.rows);
		},
		lazyLoad_onFailure:function(tbl,transport){
			tbl.hasNoMore=true;
			var lastRow=tbl.down("tr.listmore");
			if(404==transport.status){
				lastRow.remove();
			} else if(401==transport.status){
				ui.handleSessionExpired();
			} else if(transport.responseJSON && transport.responseJSON.error){
				lastRow.innerHTML=transport.responseJSON.error;
			} else {
				lastRow.innerHTML="There was an error. The server said:\n\n"+transport.responseText;
			}
		},
		
		/**
		 * Generates a grid wrapper inside the document body.
		 * @param showSlots Whether to generate light boxes in the background to show empty spaces in the grid. Default false. 
		 * @param gridId The HTML id of the grid wrapper. Default "grid".
		 * @return the grid wrapper element.
		 */
		grid:function(showSlots, gridId){
			var slots='';
			if(!gridId){ gridId="grid"; }
			if(showSlots){
				slots=ui.gridSlots();
			}
			var out='<div class="grid" id="'+gridId+'">'+slots+'</div>';
			document.getElementById("content").innerHTML+=out;
			var grid=$(gridId);
			grid.box=function(box){ return ui.box(box,grid); }
			grid.tabSet=function(tabSet){ return ui.tabSet(tabSet,grid); }
			return grid;
		},
		gridSlots:function(){
			slots="";
			for(r=1;r<=3;r++){
				for(c=1;c<=3;c++){
					slots+='<div class="noprint boxslot r'+r+' c'+c+'" data-gridrow="'+r+'" data-gridcol="'+c+'"></div>';
				}	
			}
			return slots;
		},


		/**
		 * Writes a tree node. 
		 * {
		 * 	id: The id of the header. The body will have the same ID plus "_body".
		 *  record: The object represented by this tree item. May be used by the updater, for example.
		 *  updater: A function to generate and insert the body content. It should expect the tree item header as a parameter.
		 *  header: The title shown on the tree node.
		 *  content: Static HTML content to use instead of an updater function.
		 *  url: Optional URL for AJAX request, by default writes table
		 *  headers: Array oftable headers after AJAX request
		 *  cellTemplates: Array of table cell templates after AJAX request
		 *  successHandler: Optional, success handler function(transport, treeItem) for AJAX request
		 *  requestHeaders: Optional, key-value pairs for AJAX request headers
		 * }
		 */
		treeItem:function(item,parent){
			if(null!=parent && parent.down(".boxbody")){ parent=parent.down(".boxbody"); }
			var ti=document.createElement("div").addClassName("treeitem closed");
			var head=document.createElement("h3").addClassName("treehead");
			var toggle=document.createElement("span").addClassName("toggleitem");
			var timg=document.createElement("img");
			timg.src="/skins/"+skin+"/images/icons/btn_plus.gif";
			timg.className="noprint";
			toggle.appendChild(timg);
			head.appendChild(toggle);
			ti.appendChild(head);
			head.innerHTML+=item.header;
			var tb=document.createElement("div").addClassName("treebody");
			if(item.content){ 
				tb.innerHTML=tb.content; 
			} else if(item.updater){
				tb.innerHTML='Loading...'; 
				ti.updater=item.updater;
			}
			ti.appendChild(tb);
			if(item.id){
				ti.id=item.id;
				head.id=item.id+"_head";
				tb.id=item.id+"_body";
			}
			ti.form=function(frm){ return ui.form(frm,tb) };
			tb.form=function(frm){ return ui.form(frm,tb) };
			ti.treeItem=function(item){ return ui.treeItem(item,tb) };
			tb.treeItem=function(item){ return ui.treeItem(item,tb) };
			ti.table=function(tbl,data){ return ui.table(tbl,data,tb); }
			tb.table=function(tbl,data){ return ui.table(tbl,data,tb); }
			if(item.url && !item.updater){
				ti.url=item.url;
				var successHandler=function(transport){
					tb.table({ headers:item.headers, cellTemplates:item.cellTemplates }, transport.responseJSON);
				}
				if(item.successHandler){ successHandler=item.successHandler; }
				if(item.url.indexOf("?")>1){
					ti.url+="&";
				} else {
					ti.url+="?";
				}
				if(!tb.dataset.pagesize){ tb.dataset.pagesize=25; }
				ti.url+="pagenumber=1&pagesize="+tb.dataset.pagesize;
				if(-1!=ti.url.indexOf(window.location.host)){
					new Ajax.Request(ti.url,{
						method:'get',
						onSuccess:function(transport){ successHandler(transport, ti)},
						onFailure:function(transport){ ui.defaultFailureHandler(transport, ti)}
					});
				} else {
					ti.requestHeaders=item.requestHeaders;
					AjaxUtils.remoteAjax(
							ti.url,
							'get',
							{},
							function(transport){ successHandler(transport, ti)},
							function(transport){ ui.defaultFailureHandler(transport, ti)},
							ti.requestHeaders
					);
				}
			}

			ti.record=item.record;
			if(null!=parent){
				parent.appendChild(ti);
			}
			head.observe("click",ui.toggleTreeItem);
			return ti;
		},
		
		toggleTreeItem:function(evt){
			var ctrl=$(evt.target);
			var item=ctrl.up(".treeitem");
			var toOpen=item.hasClassName("closed");
			var img=item.down("img");
			if(toOpen){
				img.src=img.src.replace("plus","minus");
				item.removeClassName("closed");
				var tb=item.down(".treebody");
				if(item.updater){
					item.updater(ctrl);
				}
			} else {
				img.src=img.src.replace("minus","plus");
				item.addClassName("closed");
			}
		},
		
		
		/**
		 * Processes a named template from this UI class.
		 */
		doTemplate:function(templateName, replacements){
			var tpl=ui[templateName];
			var ret=tpl;
			var keys=Object.keys(replacements);
			for(i=0;i<keys.length;i++){
				var tag=keys[i];
				ret=ret.replace('{{'+tag+'}}', replacements[tag]);
			}
			return ret;
		},

		defaultSuccessHandler:function(transport,containerData){
			ui.table(containerData,transport.responseJSON,containerData.id);
		},

		defaultFailureHandler:function(transport,parent){
			var err=transport.responseText;
			if(transport.responseJSON && transport.responseJSON.error){
				err=transport.responseJSON.error;
			}
			if(parent.down(".boxbody")){
				parent=parent.down(".boxbody");
			}
			parent.innerHTML=err;
		},
		
		handleSessionExpired:function(){
			alert("Your session has expired, or you logged out in another tab. When you click OK, you can log in again.")
			document.location.reload();
		},
		
		form:function(frm,parent){
			if(!frm.id){ frm.id='frm_'+Math.floor(1000000*Math.random()); }
			if(undefined===frm.readonly && undefined!==canEdit){ frm.readonly=!canEdit; }
			var f=document.createElement("form");
			f.id=frm.id;
			f.action=frm.action;
			if(undefined!==frm.readonly){ f.dataset.readonly= (frm.readonly==true ? 1 : 0); }
			if(undefined!==frm.autosubmit && frm.autosubmit==false){ f.addClassName("suppressautoupdate"); }
			f.dataset.ajaxmethod=(frm.method) ? frm.method : "post";
			if(frm.classes){ f.addClassName(frm.classes); }
			if(null!=parent){
				if(parent.down(".boxbody")){ parent=parent.down(".boxbody") }
				$(parent).appendChild(f);
			}
			f.hiddenField=function(fieldName,fieldValue){ return ui.hiddenField(fieldName,fieldValue,f); }
			f.textField=function(field){ return ui.textField(field,f); }
			f.textArea=function(field){ return ui.textArea(field,f); }
			f.passwordField=function(field){ return ui.passwordField(field,f); }
			f.fileField=function(field){ return ui.fileField(field,f); }
			f.formField=function(field){ return ui.formField(field,f); }
			f.roleField=function(field){ return ui.roleField(field,f); }
			f.dropdown   =function(field){ return ui.dropdown(field,f); }
			f.checkbox   =function(field){ return ui.checkbox(field,f); }
			f.createButton=function(options){ return ui.createButton(f,options); }
			f.buttonField=function(field){ return ui.buttonField(field,f); }
			f.submitButton=function(field){ return ui.submitButton(field,f); }
			f.datePicker=function(field){ return ui.datePicker(field,f); }
			f.dateTimePicker=function(field){ return ui.dateTimePicker(field,f); }
			f.dateField=function(field){ return ui.dateField(field,f); }
			f.dateTimeField=function(field){ return ui.dateTimeField(field,f); }
			if('get'!=f.dataset.ajaxmethod){
				f.hiddenField("csrfToken",csrfToken);
			}
			return $(f);
		},
		formField:function(field,parent){
			var lbl=document.createElement("label");
			lbl.htmlFor=field.name;
			if(field.id){ lbl.id=field.id+"_label"; }
			var s=document.createElement("span").addClassName("label");
			s.innerHTML=field.label;
			lbl.appendChild(s);
			if(field.content){ lbl.innerHTML+=field.content; }
			if(field.afterUpdate){ lbl.afterUpdate=field.afterUpdate; }
			if(null!=parent){ $(parent).appendChild(lbl); }
			return $(lbl);
		},
		addHelpText:function(label,fieldName){
			if(helpTexts && helpTexts[fieldName]){
				var h=document.createElement("div").addClassName("helptext");
				h.innerHTML=helpTexts[fieldName];
				label.appendChild(h);
			}
		},
		addSuppliedHelpText:function(label,suppliedText){
			var h=document.createElement("div").addClassName("helptext");
			h.innerHTML=suppliedText;
			label.appendChild(h);
		},
		createButton:function(parent,options){
			if(!options){ options={}; }
			var lbl=document.createElement("label");
			var cb=document.createElement("input");
			cb.type="button";
			cb.value="Create";
			cb.options=options;
			if(options.beforeSubmit){
				cb.onclick=function(){ options.beforeSubmit(); ui.submitForm(cb); }
			} else {
				cb.onclick=function(){ ui.submitForm(cb); }
			}
			lbl.appendChild(cb);
			if(null!=parent){ 
				$(parent).appendChild(lbl);
				lbl.up("form").addClassName("suppressautoupdate");
			}
			return $(lbl);
		},
		buttonField:function(field,parent){
			var lbl=document.createElement("label");
			var b=document.createElement("input");
			if(field.id){ b.id=field.id; }
			b.type="button";
			b.value=field.label;
			b.onclick=field.onclick;
			lbl.appendChild(b);
			if(null!=parent){ 
				$(parent).appendChild(lbl);
				if(lbl.up("form")){
					lbl.up("form").addClassName("suppressautoupdate");
				}
			}
			return $(lbl);
		},
		submitButton:function(field,parent){
			var lbl=document.createElement("label");
			var b=document.createElement("input");
			if(field.id){ b.id=field.id; }
			b.type="submit";
			b.value=field.label;
			lbl.appendChild(b);
			if(null!=parent){ 
				$(parent).appendChild(lbl);
				lbl.up("form").addClassName("suppressautoupdate");
			}
			return $(lbl);
		},
		passwordField:function(field,parent){
			field.type="password";
			return ui.textField(field,parent);
		},
		hiddenField:function(fieldName,fieldValue,parent){
			var f=document.createElement("input");
			f.type="hidden";
			f.name=fieldName;
			f.id=fieldName;
			f.value=fieldValue;
			if(null!=parent){
				$(parent).appendChild(f);
			}
			return $(f);
			
		},
		
		/**
		 * Writes a text input field with its label.
		 * Parameters for field:
		 * label The user-frendly ame for the field
		 * name The form field name that goes to the server
		 * value The default value if the field. If not specified, and this is a View page for a record, defaults to the value of field.name for that record.
		 * readonly Whether the field can be edited. If not specified, inherits from parent.
		 */
		textField:function(field,parent){
			var lbl=ui.formField(field);
			if(undefined==field.readonly && null!=parent && undefined!==parent.dataset.readonly){ field.readonly=parseInt(parent.dataset.readonly); }
			if(!field.value && data && data[field.name]!==null){ field.value=data[field.name]; }
			if(!field.value){ field.value=""; }
			if(field.readonly){
				if(""==field.value||!field.value){ field.value="&nbsp;"; }
				lbl.innerHTML+=field.value;
			} else {
				var tb=ui.textBox(field, lbl);
			}
			if(null!=parent){
				$(parent).appendChild(lbl);
			}
			return $(lbl);
		},

		textBox:function(field,parent){
			if(undefined==field.readonly && null!=parent && undefined!==parent.dataset.readonly){ field.readonly=parseInt(parent.dataset.readonly); }
			if(!field.value && data && data[field.name]!==null){ field.value=data[field.name]; }
			if(!field.value){ field.value=""; }
			var tb;
			if(field.readonly){
				if(""==field.value||!field.value){ field.value="&nbsp;"; }
				tb=document.createElement("span");
				tb.innerHTML=ui.decodeHtmlEntities(field.value);
			} else {
				tb=document.createElement("input");
				tb.type="text";
				if(field.type){ tb.type=field.type; }
				tb.name=field.name;
				if(field.id){ 
					tb.id=field.id;
				} else {
					tb.id=tb.name;
				}
				tb.value=ui.decodeHtmlEntities(field.value);
				tb.oldvalue=ui.decodeHtmlEntities(field.value);
				if(field.apiUrl){
					tb.dataset.apiurl=field.apiUrl;
				}
				tb.observe("keyup",function(){ ui.updateFormField(tb); });
				tb.observe("click",function(){ ui.updateFormField(tb); });
				tb.observe("blur",function(){ ui.doUpdateFormField(tb); });
			}
			if(null!=parent){
				$(parent).appendChild(tb);
			}
			return $(tb);
		},

		textArea:function(field,parent){
			var lbl=ui.formField(field);
			if(undefined==field.readonly && null!=parent && undefined!==parent.dataset.readonly){ field.readonly=parseInt(parent.dataset.readonly); }
			if(!field.value && data && undefined!=data[field.name]){ field.value=data[field.name]; }
			if(!field.value){ field.value=""; }
			if(field.readonly){
				if(""==field.value||!field.value){ field.value="&nbsp;"; }
				lbl.innerHTML+=field.value;
			} else {
				var tb=document.createElement("textarea");
				tb.name=field.name;
				if(field.id){ 
					tb.id=field.id;
				} else {
					tb.id=tb.name;
				}
				if(!field.value){ field.value=""; }
				tb.innerHTML=ui.decodeHtmlEntities(field.value);
				tb.oldvalue=ui.decodeHtmlEntities(field.value);
				lbl.appendChild(tb);
				if(field.helpText){
					ui.addSuppliedHelpText(lbl,field.helpText);
				} else {
					ui.addHelpText(lbl,field.name);
				}
				lbl.down("textarea").observe("keyup",function(){ ui.updateFormField(lbl.down("textarea")); });
				lbl.down("textarea").observe("click",function(){ ui.updateFormField(lbl.down("textarea")); });
				lbl.down("textarea").observe("blur",function(){ ui.doUpdateFormField(lbl.down("textarea")); });
			}
			if(null!=parent){
				$(parent).appendChild(lbl);
			}
			return $(lbl);
		},

		/**
		 * Returns an unwrapped SELECT element for insertion into other elements. 
		 * 
		 * 
		 * @param Object field Describes the field. Parameters include: 
		 * @param Element|null parent An HTML element into which the SELECT should be inserted.
		 * @see ui.dropdownElement for parameters in field.
		 */
		dropdown:function(field,parent){
			if(undefined==field.readonly && null!=parent && undefined!==parent.dataset.readonly){ field.readonly=parseInt(parent.dataset.readonly); }
			if(!field.value && data && undefined!=data[field.name]){ field.value=data[field.name]; }
			if(!field.value){ field.value=""; }
			var lbl=ui.formField(field);
			ui.dropdownElement(field,lbl);
			ui.addHelpText(lbl,field.name);
			if(null!=parent){
				$(parent).appendChild(lbl);
			}
			return $(lbl);
		},
		/**
		 * Returns an unwrapped SELECT element for insertion into other elements. 
		 * 
		 * @param Object field Describes the field. Parameters include: 
		 * 			- name Required. The name that will be sent to the server, e.g., an object property name.
		 * 			- options Required. An array of objects containing at minimum "value" and "label" properties.
		 * 			- readonly Optional. If specified, overrides the readonly attribue of any parent form. Default false.
		 * 			- value Optional. The value that should be pre-selected.
		 * 			- id Optional An HTML ID for the SELECT element.
		 * 			- apiUrl Optional If specified, the UL to which any updates should be submitted.
		 * @param Element|null parent An HTML element into which the SELECT should be inserted.
		 */
		dropdownElement:function(field,parent){
			if(undefined==field.readonly && null!=parent && undefined!==parent.dataset.readonly){ field.readonly=parseInt(parent.dataset.readonly); }
			if(!field.value && data && undefined!=data[field.name]){ field.value=data[field.name]; }
			if(!field.value){ field.value=""; }
			var s;
			if(field.readonly){
				s=document.createElement("span");
				s.innerHTML+=field.value;
			} else {
				s=document.createElement("select");
				s.name=field.name;
				s.oldvalue=field.value;
				if(field.id){ 
					s.id=field.id;
				} else {
					s.id=s.name;
				}
				field.options.each(function(o){
					var seld='';
					if(o.value==field.value){ seld=' selected="selected" '; }
					s.innerHTML+='<option '+seld+' value="'+o.value+'">'+o.label+'</option>';
				});
				if(field.apiUrl){
					s.dataset.apiurl=field.apiUrl;
				}
				s.observe("change",function(){ ui.updateFormField(s); });
				s.observe("blur",function(){ ui.doUpdateFormField(s); });
			}
			if(null!=parent){
				$(parent).appendChild(s);
			}
			return $(s);
		},

		/**
		 * Returns a checkbox field. If parent specified, also appends the ceckbox field to the parent.
		 * @param Object field A descriptioon of the form field. Parameters can include:
		 * 						- readonly Whether the field is read-only. Default is paret form's readonly seting.
		 * 						- name The name to be submitted to the server
		 * 						- label The user-friendly label text for the form field.
		 * 						- handler An optional function to handle changes in state. Function receives the hidden input in the label element as a parameter.
		 * @param Element parent The parent element (usually a form)
		 */
		checkbox:function(field,parent){
			if(undefined==field.readonly && null!=parent && undefined!==parent.dataset.readonly){ field.readonly=parseInt(parent.dataset.readonly); }
			if(!field.value && data && undefined!=data[field.name]){ field.value=data[field.name]; }
			if(!field.value){ field.value=""; }
			var lbl=ui.formField(field);


			var img=document.createElement("img");
			var checked="no";
			var prefix="";
			if(field.checked){ checked="yes"; field.value=1; }
			if(field.value && 1==field.value){ checked="yes"; }
			if(!field.readonly){ prefix="btn_"; }
			img.src="/images/icons/"+theme+"theme/"+prefix+checked+".gif";
			img.setStyle({ marginBottom:0, lineHeight:"1em" });
			lbl.appendChild(img);
			if(!field.readonly){
				var cb=document.createElement("input");
				cb.type="hidden";
				cb.name=field.name;
				if(field.value && 1==field.value){ cb.value=1; }
				if(field.readonly){ cb.disabled=true; }
				if(field.handler){
					lbl.handler=field.handler;
				} else {
					lbl.handler=ui.updateFormField;
				}
				lbl.appendChild(cb);

				img.observe("click",function(evt){
					var img=evt.target;
					var lbl=img.up("label");
					var inp=lbl.down("input");
					if(img.src.indexOf("no.gif")>0){
						img.src=img.src.replace("no.gif","yes.gif");
						inp.value=1;
					} else {
						img.src=img.src.replace("yes.gif","no.gif");
						inp.value=0;
					}
					lbl.handler(inp);
				});
			}
			
			if(field.helpText){
				ui.addSuppliedHelpText(lbl,field.helpText);
			} else {
				ui.addHelpText(lbl,field.name);
			}
			if(null!=parent){
				$(parent).appendChild(lbl);
			}
			return $(lbl);
		},
		fileField:function(field,parent){
			var lbl=ui.formField(field);
			var ff=document.createElement("input");
			ff.type="file";
			ff.name=field.name;
			lbl.appendChild(ff);
			//lbl.up("form").enctype="multipart/formdata";
			if(null!=parent){
				$(parent).appendChild(lbl);
				lbl.up("form").enctype="multipart/form-data";
			}
			return $(lbl);
		},

		roleField:function(field,parent){
			//	frm.roleField({ label:"Owner", name:'owner', parentObject:data, otherType:'user', idField:'owner', labelField:'ownername', readonly:(!isAdmin &&!isOwner) });
			if(undefined==field.readonly && null!=parent && undefined!==parent.dataset.readonly){ field.readonly=parseInt(parent.dataset.readonly); }
			if(!field.value && data && undefined!=data[field.name]){ field.value=data[field.name]; }
			if(!field.value){ field.value=""; }
			var lbl=ui.formField(field);
			var hi=document.createElement("input");
			if(!field.otherId){
				field.otherId="";
				field.otherName="None set";
			}
			hi.type="hidden";
			hi.name=field.name;
			hi.value=field.otherId;
			hi.oldValue=field.otherId;
			lbl.appendChild(hi);
			var a=document.createElement("a")
			a.href='/'+field.otherType+'/'+field.otherId;
			a.innerHTML=field.otherName;
			lbl.appendChild(a);
			if(!field.readonly){
				var b=document.createElement("input");
				b.type="button";
				b.value="Change...";
				b.style.marginLeft="0.5em";
				b.onclick=function(){ 
					$$(".currentrolefield").each(function(elem){ elem.removeClassName("currentrolefield") });
					b.up("label").addClassName("currentrolefield");
					ui.findRole(field); 
				}
				lbl.appendChild(b);
			}
			ui.addHelpText(lbl,field.name);
			if(null!=parent){
				$(parent).appendChild(lbl);
			}
			lbl.fieldData=field;
			return $(lbl);
		},
		
		findRole:function(field){
			var headers=field.headers.slice();
			headers.push('&nbsp;');
			var cells=field.cellTemplates.slice()
			cells.push('<input type="button" value="Choose" onclick="ui.setRole(this)" />');
			var constraint="";
			if(field.constraint){
				var k=(Object.keys(field.constraint))[0];
				var v=field.constraint[k];
				constraint="/"+k+"/"+v;
			}
			var b=ui.modalBox({
				'url':'/api/'+field.otherType+constraint,
				'title':'Find '+field.otherType+'s',
				'headers':headers,
				'cellTemplates':cells
			});
		},
		
		setRole:function(btn){
			var parentRole=$(document.body).down(".currentrolefield");
			var newRole=btn.up("tr").rowData;
			parentRole.removeClassName("currentrolefield");
			var link=parentRole.down("a");
			var nameField=parentRole.fieldData.labelField || 'name';
			var idField='id';
			link.innerHTML=newRole[nameField];
			link.href='/'+parentRole.fieldData.otherType+'/'+newRole[idField];
			ui.closeModalBox();
			var hi=parentRole.down("input");
			hi.value=newRole[idField];
			parentRole.roleRecord=newRole;
			ui.updateFormField(hi);
		},
		
		updateFormField:function(field){
			window.clearTimeout(submitTimer);
			if(field.tagName=="input" && ("hidden"==field.type ||"text"==field.type || "password"==field.type) && !validator.validate(field)){
				return false;
			}
			if(field.up("label,td")){ field.up("label,td").removeClassName("invalidfield"); }
			if(field.up(".suppressautoupdate") && !field.dataset.apiurl){ return false; }
			window.submitTimer=setTimeout(function(){ ui.doUpdateFormField(field) },1000);
		},
		
		doUpdateFormField:function(field){
			if(field.oldvalue==field.value){ return false; }
			if(field.up(".suppressautoupdate") && !field.dataset.apiurl){ return false; }
			if(field.up("label,td")){ field.up("label,td").addClassName("updating"); }
			var body;
			var apiUrl='';
			if(field.dataset.apiurl){
				apiUrl=field.dataset.apiurl;
			} else if(field.up("form")){
				apiUrl=field.up("form").action;
			}
			if(field.type && field.type=="checkbox"){
				body=field.name+"="+(field.checked ? "1" : "0")+"&csrfToken="+csrfToken
				field.oldvalue=field.checked ? "0" : "1";
			} else {
				field.oldvalue=field.value;
				body=field.name+"="+encodeURIComponent(field.value)+"&csrfToken="+csrfToken
			}
			window.setTimeout(function(){
				new Ajax.Request(apiUrl,{
					method:'patch',
					postBody:body,
					onSuccess:function(transport){ ui.updateFormField_onSuccess(transport,field) },
					onFailure:function(transport){ ui.updateFormField_onFailure(transport,field) }
				});
			},250);
		},
		
		updateFormField_onSuccess:function(transport,field){
			field.up("label,td").removeClassName('updating');
			var afterUpdate=field.up("label,td").afterUpdate;
			if(field.up("label")){
				field.up("label").removeClassName('invalidfield');
			} else {
				field.removeClassName('invalidfield');
			}
			if(afterUpdate){ afterUpdate(field); }
		},
		updateFormField_onFailure:function(transport,field){
			field.up("label,td").removeClassName('updating');
			if(401==transport.status){
            	ui.handleSessionExpired();
            	return;
            }
			if(field.up("label")){
				field.up("label").addClassName('invalidfield');
			} else {
				field.addClassName('invalidfield');
			}
			if(transport.responseJSON && transport.responseJSON.error){
				alert(transport.responseJSON.error);
			} else {
				alert(transport.responseText);
			}
		},
		
		submitForm:function(submitButton){
			var frm=submitButton.up("form");
			if(frm.down("invalidfield")){ return false; }
			var fields=frm.select("input[type=hidden], input[type=text], input[type=password], input[type=file], select, textarea");
			var isValid=true;
			var formData=new FormData();
			fields.each(function(f){
				if(!validator.validate(f)){
					isValid=false;
				} else if("file"==f.type){
					formData.append(f.name, f.files[0], f.files[0].name)
				} else {
					formData.append(f.name, encodeURIComponent(f.value));
				}
			});
			if(!isValid){return false; }
			submitButton.up("label,tr,div").addClassName("updating");
			var xhr=new XMLHttpRequest();
			var method=frm.method;
			if(frm.dataset.ajaxmethod){ method=frm.dataset.ajaxmethod; }
	        xhr.open(method, frm.action, true);
	        xhr.onload=function(){
	        	try{
	        		xhr.responseJSON=JSON.parse(xhr.responseText);
	        	} catch(ex) {
	        		//just eat it
	        	}
	            if(200==xhr.status || 201==xhr.status){
	                ui.submitForm_onSuccess(xhr,submitButton);
	            } else if(401==xhr.status){
	            	ui.handleSessionExpired();
	            } else {
	                ui.submitForm_onFailure(xhr,submitButton);
	            }
	        }			
			xhr.send(formData);
		},
		submitForm_onSuccess:function(transport,submitButton){
			if(!transport.responseJSON || transport.responseJSON.error){
				return ui.submitForm_onFailure(transport,submitButton);
			}
			submitButton.up("label,tr,div").removeClassName("updating");
			if(transport.responseJSON.created){
				if(submitButton.options && submitButton.options.afterSuccess){
					return submitButton.options.afterSuccess(transport.responseJSON);
				}
				window.location='/'+transport.responseJSON.type+'/'+transport.responseJSON.created.id;
			}
		},
		submitForm_onFailure:function(transport,submitButton){
			submitButton.up("label,tr,div").removeClassName("updating");
			if(transport.responseJSON && transport.responseJSON.error){
				alert(transport.responseJSON.error);
			} else {
				alert(transport.responseText);
			}
		},
		
		checkmark:function(obj, field){
			var str=obj[field];
			str=str.toLowerCase();
			if("1"==str || "yes"==str || "true"==str){
				return '<img src="/images/icons/yes.gif" />';
			}
			return '&nbsp;';
		},
		
		/** 
		 * Writes a date picker field with its label, with the time fields enabled. 
		 * @see datePicker for documentation.
		 */
		dateTimePicker:function(field, parent){
			field['showTime']=true;
			return ui.datePicker(field, parent);
		},
		dateField:function(field,parent){
			return ui.datePicker(field, parent);
		},
		dateTimeField:function(field,parent){
			return ui.datePicker(field, parent);
		},
		
		/**
		 * Writes a date picker field with its label. 
		 * Sets and sends a GMT date string (YYYY-MM-DD HH:MM:SS), but displays in LOCAL time.
		 * 
		 * Common parameters for field:
		 * 
		 * label The user-frendly mame for the field
		 * name The form field name that goes to the server
		 * value The default value if the field. If not specified, and this is a View page for a record, defaults to the value of field.name for that record.
		 * readonly Whether the field can be edited. If not specified, inherits from parent.
		 * 
		 * Date picker parameters:
		 * 
		 * showTime: if true, hour and minute SELECTs will be shown under the calendar. Seconds will be unchanged.
		 * minuteStep: Show only minutes divisible by minuteStep. If undefined, same as 1 (all minutes).
		 *             Example: if 5, minutes will be 00, 05 ... 50, 55.
		 *             If the existing value does not correspond to one of those shown, the next lowest will be selected.
		 */
		datePicker:function(field, parent){
			var now=new Date();
			var offsetMins=now.getTimezoneOffset();
			var lbl=ui.formField(field);
			if(undefined==field.readonly && null!=parent && undefined!==parent.dataset.readonly){ field.readonly=parseInt(parent.dataset.readonly); }
			if(!field.value && data && data[field.name]!==null){ field.value=data[field.name]; }
			if(!field.value){ 
				field.value=now.toISOString().replace("T"," ").substr(0,19);
			}
			if(field.readonly){
				lbl.innerHTML+='<span class="datepickerfriendlydate">'+ui.friendlyDate(field.value)+'</span>';
			} else {
				lbl.dataset.gmtOffset=offsetMins;
				lbl.dpDate=new Date(field.value);
				lbl.selectedDate=new Date(field.value);
				lbl.dpDate.setMinutes(lbl.dpDate.getMinutes()-offsetMins); //Correct from GMT to local
				lbl.selectedDate.setMinutes(lbl.dpDate.getMinutes()-offsetMins); //Correct from GMT to local for display
				var dp='';
				dp='<input type="hidden" name="'+field.name+'" id="'+field.name+'" value="'+field.value+'" />';
				dp+='<span class="datepickerfriendlydate">'+ui.friendlyDate(field.value)+'</span> <input type="button" value="Change..." onclick="ui.datePickerShow(this);return false"/>';
				dp+='<div class="datepicker" style="display:none;">';
				dp+='<div class="datepickercalendar" style="width:20em">';
				
				dp+='</div>';
				if(field.showTime){
					dp+='<span style="display:inline-block;width:21em;border-top:1px solid #666">';

					if(!field.minuteStep){ field.minuteStep=1; }
					var step=field.minuteStep;
					var selectedHour=lbl.dpDate.getHours();
					var selectedMinute=lbl.dpDate.getMinutes();
					if(1!=step){ selectedMinute=(Math.floor(selectedMinute/step))*step; }
					dp+='Time: <select class="datepickerhour" name="'+field.name+'_hour" onchange="ui.datePickerSet(this)">';
					for(h=0;h<24;h++){
						var selected='';
						if(h==selectedHour){ selected='selected="selected"'; }
						dp+='<option '+selected+' value="'+(h<10?'0'+h:h)+'">'+(h<10?'0'+h:h)+'</option>';
					}
					dp+='</select> : <select class="datepickerminute" name="'+field.name+'_minute" onchange="ui.datePickerSet(this)">';

					for(i=0;i<60;i+=step){
						var selected='';
						if(i==selectedMinute){ selected='selected="selected"'; }
						dp+='<option '+selected+' value="'+(i<10?'0'+i:i)+'">'+(i<10?'0'+i:i)+'</option>';
					}
					dp+='</select>';
					dp+='</soan>';
				}
				dp+='</div>';
				lbl.innerHTML+=dp;
				ui.datePickerMoveCalendar(lbl,0);
			}
			if(null!=parent){
				$(parent).appendChild(lbl);
			}
			return $(lbl);
		},
		
		datePickerShow: function(btn){
			btn.up("label").down("div.datepicker").style.display="block";
			btn.remove();
		},
		
		datePickerMoveCalendar: function(label, offset){
			if(0!=offset){
				label.dpDate.setMonth(label.dpDate.getMonth()+offset);
			}
			html='<input type="button" class="unselected" onclick="ui.datePickerMoveCalendar(this.up(\'label\'),-1);return false" value="&lt;&lt;" /> '+
			'<span style="display:inline-block;text-align:center;width:13.1em"><strong>'+
			ui.monthsOfYear[label.dpDate.getMonth()]+' '+label.dpDate.getFullYear()+
			'</strong></span>'+
			' <input type="button" class="unselected" onclick="ui.datePickerMoveCalendar(this.up(\'label\'),1);return false" value="&gt;&gt;" /><br/>';
			label.down(".datepickercalendar").innerHTML=html;

			var tempDate=new Date();
			tempDate.setFullYear(label.dpDate.getFullYear());
			tempDate.setMonth(label.dpDate.getMonth()+1);
			tempDate.setDate(0);
			var daysInMonth=tempDate.getDate();
			tempDate.setDate(1);
			var dayOfFirst=tempDate.getDay(); //0=Sunday, 6=Sat
			
			var today=new Date();
			var thisMonth=label.selectedDate.getMonth();
			var thisYear=label.selectedDate.getFullYear();
			var thisDay=label.selectedDate.getDate();
			var isThisMonthCalendar=(thisMonth==tempDate.getMonth() && thisYear==tempDate.getFullYear());

			var count=1;
			var dow=0;
			while(count<=dayOfFirst){
				var btn=document.createElement("input");
				btn.type="button";
				btn.value="00";
				btn.addClassName("unselected");
				btn.style.marginLeft='0.25em';
				btn.style.width='2.25em';
				btn.style.opacity=0.3;
				btn.style.color="transparent";
				label.down(".datepickercalendar").appendChild(btn);
				count++;
				dow++;
			}
			count=1;
			while(count<=daysInMonth){
				var btn=document.createElement("input");
				btn.type="button";
				btn.value=(count<10?"0"+count:count);
				if(!isThisMonthCalendar || count!=thisDay){
					btn.addClassName("unselected");
				}
				btn.addClassName("datepickerday");
				btn.style.marginLeft='0.25em';
				btn.style.width='2.25em';
				btn.dataset.year=label.dpDate.getFullYear();
				btn.dataset.month=label.dpDate.getMonth();
				btn.dataset.day=count;
				btn.onclick=function(evt){ var elem=evt.target; ui.datePickerSet(elem); };
				if(0==dow || 6==dow){ btn.addClassName("weekend"); }
				label.down(".datepickercalendar").appendChild(btn);
				count++;
				dow++;
				if(dow%7==0){ 
					label.down(".datepickercalendar").appendChild(document.createElement("br"));
					dow=0;
				}
			}
			while(dow!=0 && dow<=6){
				var btn=document.createElement("input");
				btn.type="button";
				btn.value="00";
				btn.addClassName("unselected");
				btn.style.opacity=0.3;
				btn.style.color="transparent";
				btn.style.marginLeft='0.25em';
				btn.style.width='2.25em';
				label.down(".datepickercalendar").appendChild(btn);
				count++;
				dow++;
			}
			label.down(".datepickercalendar").style="display:block";
		},
		
		datePickerSet:function(elem){
			var lbl=elem.up("label");
			var d=lbl.dpDate;
			var s=lbl.selectedDate;
			if(lbl.down(".datepickerminute")){ 
				d.setMinutes(lbl.down(".datepickerminute").value); 
				s.setMinutes(lbl.down(".datepickerminute").value); 
			}
			if(lbl.down(".datepickerhour")){ 
				d.setHours(lbl.down(".datepickerhour").value); 
				s.setHours(lbl.down(".datepickerhour").value); 
			}
			if(elem.hasClassName("datepickerday")){ 
				d.setDate(elem.dataset.day);
				d.setMonth(elem.dataset.month);
				d.setFullYear(elem.dataset.year);
				s.setDate(elem.dataset.day);
				s.setMonth(elem.dataset.month);
				s.setFullYear(elem.dataset.year);
				elem.up(".datepickercalendar").select("input").each(function(b){
					b.addClassName("unselected");
				});
				elem.removeClassName("unselected");
			}
			var utcMonth=s.getUTCMonth()+1;
			var utcDay=s.getUTCDate();
			var utcHours=s.getUTCHours();
			var utcMinutes=s.getUTCMinutes();
			var utcSeconds=s.getUTCSeconds();
			if(utcMonth<10){ utcMonth="0"+utcMonth; }
			if(utcDay<10){ utcDay="0"+utcDay; }
			if(utcHours<10){ utcHours="0"+utcHours; }
			if(utcMinutes<10){ utcMinutes="0"+utcMinutes; }
			if(utcSeconds<10){ utcSeconds="0"+utcSeconds; }
			var utcDateString=s.getUTCFullYear()+"-"+utcMonth+"-"+utcDay+" "+utcHours+":"+utcMinutes+":"+utcSeconds;
			$(lbl.htmlFor).value=utcDateString;
			lbl.down(".datepickerfriendlydate").innerHTML=ui.friendlyDate(utcDateString);
			ui.updateFormField(lbl.down("input"));
		},
		
		dateRegex:/^\d\d\d\d-\d\d-\d\d$/,
		dateTimeRegex:/^\d\d\d\d-\d\d-\d\d \d\d:\d\d:\d\d$/,
		friendlyDate:function(dateString){
			if(""==dateString){ 
				return "-"; 
			} else if(dateString.match(ui.dateTimeRegex)){
				return ui.friendlyDateTime(dateString);
			} else if(!dateString.match(ui.dateRegex)){
				return dateString;
			}
			var parts=dateString.split("-");
			var now =new Date(); //In local time
			var offsetMins=now.getTimezoneOffset();
			var d= new Date(parts[0], parts[1]-1, parts[2], 0, 0-offsetMins, 0); //In GMT
			//we always show the time:
			var dateStr='';
			//Now set both to 0 and work out the difference, so we know ow to write the day part
			d.setMinutes(0);
			d.setHours(0);
			d.setMilliseconds(0);
			now.setMinutes(0);
			now.setHours(0);
			now.setMilliseconds(0);

			var diffDays=(now.getTime()-d.getTime())/86400000; //milliseconds to days
			if(-3>diffDays){
				if(d.getFullYear()==now.getFullYear()){
					//23 September
					dateStr=d.getDate()+" "+ui.monthsOfYear[d.getMonth()];
				} else {
					//23 Sep 2012
					dateStr=d.getDate()+" "+ui.monthsOfYear[d.getMonth()].substr(0,3)+" "+d.getFullYear();
				}	
			} else if(-1>diffDays){
				//Tuesday, 08:54
				dateStr=ui.daysOfWeek[d.getDay()];
			} else if(0>diffDays){
				dateStr="Tomorrow";
			} else if(1>diffDays){
				dateStr="Today";
			} else if(2>diffDays){
				dateStr="Yesterday";
			} else if(4>diffDays){
				//Tuesday
				dateStr=ui.daysOfWeek[d.getDay()];
			} else if(d.getFullYear()==now.getFullYear()){
				//23 September
				dateStr=d.getDate()+" "+ui.monthsOfYear[d.getMonth()];
			} else {
				//23 Sep 2012
				dateStr=d.getDate()+" "+ui.monthsOfYear[d.getMonth()].substr(0,3)+" "+d.getFullYear();
			}
			return dateStr;
		},
		
		/**
		 * Formats a date string fro mthe server as follows:
		 * If today, "hh:mm"
		 * If yesterday, "Yesterday, hh:mm"
		 * If 2 or 3 days ago, "Friday, hh:mm"
		 * If longer ago, "12 Jan 2015, hh:mm"
		 */
		friendlyDateTime:function(dateString){
			if(""==dateString){ 
				return "-";
			} else if(dateString.match(ui.dateRegex)){
				return ui.friendlyDate(dateString);
			} else if(!dateString.match(ui.dateTimeRegex)){
				return dateString;
			}
			var regex=/[-:\s]/g;
			var parts=dateString.split(regex);
			var now =new Date(); //In local time
			var offsetMins=now.getTimezoneOffset();
			var d= new Date(parts[0], parts[1]-1, parts[2], parts[3], (1*parts[4])-offsetMins, 0); //In GMT
			//we always show the time:
			var dateStr=('0'+d.getHours()).slice(-2)+':'+('0'+d.getMinutes()).slice(-2);
			//Now set both to 0 and work out the difference, so we know ow to write the day part
			d.setMinutes(0);
			d.setHours(0);
			d.setMilliseconds(0);
			now.setMinutes(0);
			now.setHours(0);
			now.setMilliseconds(0);

			var diffDays=(now.getTime()-d.getTime())/86400000; //milliseconds to days
			if(-3>diffDays){
				if(d.getFullYear()==now.getFullYear()){
					//23 September, 08:54
					dateStr=d.getDate()+" "+ui.monthsOfYear[d.getMonth()]+", "+dateStr;
				} else {
					//23 Sep 2012, 08:54
					dateStr=d.getDate()+" "+ui.monthsOfYear[d.getMonth()].substr(0,3)+" "+d.getFullYear()+", "+dateStr;
				}	
			} else if(-1>diffDays){
				//Tuesday, 08:54
				dateStr=ui.daysOfWeek[d.getDay()]+", "+dateStr;
			} else if(0>diffDays){
				dateStr="Tomorrow, "+dateStr;
			} else if(1>diffDays){
				dateStr="Today, "+dateStr;
			} else if(2>diffDays){
				dateStr="Yesterday, "+dateStr;
			} else if(4>diffDays){
				//Tuesday, 08:54
				dateStr=ui.daysOfWeek[d.getDay()]+", "+dateStr;
			} else if(d.getFullYear()==now.getFullYear()){
				//23 September, 08:54
				dateStr=d.getDate()+" "+ui.monthsOfYear[d.getMonth()]+", "+dateStr;
			} else {
				//23 Sep 2012, 08:54
				dateStr=d.getDate()+" "+ui.monthsOfYear[d.getMonth()].substr(0,3)+" "+d.getFullYear()+", "+dateStr;
			}
			return dateStr;
		},
		fieldToFriendlyDate:function(obj,field){
			var str=obj[field];
			return ui.friendlyDate(str);
		},
		
		/**
		 * Returns a representation of the interval in a sensible unit. 
		 * If under 60s, returns "X sec"; under 1hr, "X min"; under 48hr, "x hr"; else "x days"
		 */
		secondsToFriendlyUnits:function(seconds){
			if(isNaN(seconds)){ return "??"; }
			if(seconds<60){ return Math.floor(seconds)+" sec"; }
			if(seconds<7200){ return Math.floor(seconds/60)+" min"; }
			if(seconds<172800){ return Math.floor(seconds/3600)+" hr"; }
			return Math.floor(seconds/86400)+" days";
		},
		
		
		decodeHtmlEntities:function(str){
			//See http://stackoverflow.com/questions/7394748/whats-the-right-way-to-decode-a-string-that-has-special-html-entities-in-it
			var ta=document.createElement("textarea");
			ta.innerHTML=str;
			return ta.value;
		},

		
		/* 
		 * SMALL SCREEN / MOBILE function
		 */

		/**
		 * Whether the current screen sizes trigger the "small screen" CSS. This relies on a custom --icebear-smallscreen property
		 * being set to 0 by default and to 1 in the small-screen CSS (as applied by media query). See :root in base.css.
		 */
		isSmallScreen:false,
		
		checkForSmallScreen:function(){
			ui.isSmallScreen=(1==(window.getComputedStyle(document.body).getPropertyValue('--icebear-smallscreen').trim()));
		},
		
		smallScreenThresholdCrossed:function(){
			console.log(ui.wasSmallScreen+" "+ui.isSmallScreen);
			if(undefined===ui.wasSmallScreen){ return false; }
			return ui.isSmallScreen!==ui.wasSmallScreen;
		},
		
		smallScreenInit:function(){
			var b=$(document.body);
			if(b.down(".tabset .current")){
				b.down(".tabset .current").addClassName("smallscreen_open");
			} else if(b.down(".box h2, .tabset h2")){
				b.down(".box h2, .tabset h2").addClassName("smallscreen_open");
			}
			$$(".box h2, .tabset h2").each(function(h){
				h.observe("click",ui.smallScreenToggleOpen);
			});
			ui.checkForSmallScreen();
			ui.wasSmallScreen=ui.isSmallScreen;
			Event.observe(window, "resize",function(){
				ui.checkForSmallScreen();
			});
		},
		
		smallScreenToggleOpen:function(evt){
			var header=$(evt.target);
			var wasCurrent=header.hasClassName("smallscreen_open");
			$$(".box h2, .tabset h2").each(function(elem){
				elem.removeClassName("smallscreen_open");
			});
			if(!wasCurrent){
				header.addClassName("smallscreen_open");
				if(ui.isSmallScreen){
					header.scrollTo();
				}
			}
		},
		
}

var validator={

		validate:function(field){
			var fieldName=field.name;
			var isValid=true;
			var err="";
			if(!fieldValidations || !fieldValidations[fieldName]){
				return true;
			}
			var validations=fieldValidations[fieldName];
			if(!(validations instanceof Array)){
				if(!validator.isValid(validations,field.value)){
					isValid=false;
					err="This "+validationPatterns[validations]["message"];
				}
			} else {
				for(i=0;i<validations.length;i++){
					if(!validator.isValid(validations[i],field.value)){
						isValid=false;
						err="This "+validationPatterns[validations[i]]["message"];
					}
				}
			}
			if(field.up("label")){
				var lbl=field.up("label");
				if(!isValid){
					lbl.addClassName("invalidfield");
					if(lbl.down(".helptext")){ lbl.down(".helptext").hide(); }
					if(lbl.down(".errortext")){
						lbl.down(".errortext").remove();
					}
					var et=document.createElement("div").addClassName("errortext");
					et.innerHTML=err;
					lbl.appendChild(et);
				} else {
					lbl.removeClassName("invalidfield");
					if(lbl.down(".errortext")){
						lbl.down(".errortext").remove();	
						if(lbl.down(".helptext")){ lbl.down(".helptext").show(); }
					}
				}
			}
			return isValid;
		},
		isValid:function(validationType,fieldValue){
			var vtype=validationPatterns[validationType];
			if(!vtype){ return true; } //no validation for this type, assume true and let the server sort it
			if(vtype.helper){
				if(validator[vtype.helper]){ return validator[vtype.helper](fieldValue); }
				return vtype.helper(fieldValue);
			} else if(vtype.pattern){
				var re=new RegExp("^"+vtype.pattern+"$");
				if(!re.test(fieldValue)){
					return false;
				}
			}
			return true;
		},
		isValidEmailAddress:function(str){
			if(str.match(/^.*@.*$/)){ return true; }
			return false;
		},
		isValidDnaSequence:function(str){
			str=str.replace(/\s/g,'');
			if(str.length%3!=0 || !str.match(/^[acgtACGT]*$/)){ return false; }
			return true;
		},
		
}

/*********************************************
 * Drag and drop
 *********************************************/

var DragDrop={

	initialized:false,
	dragging:false,
	draggedElement:null,
	startX:null,
	startY:null,
	offsetX:null,
	offsetY:null,
	oldZIndex:null,
	
	initialize:function(){
		DragDrop.initialized=true;
		$(document).observe("mousedown", DragDrop.mouseDown);
		$(document).observe("mousemove", DragDrop.mouseMove);
		$(document).observe("mouseup", DragDrop.mouseUp);
	},
	
	setup:function(draggables, droppables, doneCallback, abortCallback){
		if(!DragDrop.initialized){
			DragDrop.initialize();
		}
		if(!draggables || 0==draggables.length){ return false; }
		if(!droppables || 0==droppables.length){ return false; }
		draggables.each(function(draggable){
			draggable.addClassName("draggable");
			draggable.droppables=droppables;
			draggable.dragDoneCallback=doneCallback;
			draggable.dragAbortedCallback=abortCallback;
		});
	},

	
	
	mouseDown:function(e){
		if(null==e){ e=window.event; }
		var elem=e.target;
		if(null==elem){ elem=e.srcElement; }
		if(!$(elem).hasClassName("draggable") && !$(elem).hasClassName("handle")){ return false; }
		if(elem.hasClassName("handle")){
			elem=elem.up(".draggable");
		}
		DragDrop.dragging=true;
		DragDrop.draggedElement=elem;
		DragDrop.draggedElement.addClassName("dragging");
		var posx, posy;
		if(elem.up(".boxbody")){
			var oldParent=elem.up(".boxbody");
			posx=elem.cumulativeOffset().left-oldParent.up().up().cumulativeOffset().left;
			posy=elem.cumulativeOffset().top-oldParent.up().up().cumulativeOffset().top;
			elem.oldParent=oldParent;
			if(elem.nextSibling){ elem.oldNextSibling=elem.nextSibling; }
			if("absolute"!=elem.style.position){
				elem.dataset.wasrelative=1;
			}
			elem.dataset.wastop=elem.positionedOffset().top;
			elem.dataset.wasleft=elem.positionedOffset().left;
			elem.setStyle({
				width:elem.measure("width")+"px",
				height:elem.measure("height")+"px"
			});
			elem.absolutize();
			elem.up(".box").up().appendChild(elem.remove());
		} else {
			elem.absolutize();
			posx=elem.positionedOffset().left;
			posy=elem.positionedOffset().top;
		}
		DragDrop.startX=e.clientX;
		DragDrop.startY=e.clientY;
		DragDrop.endX=null;
		DragDrop.endY=null;
		DragDrop.offsetX=posx;
		DragDrop.offsetY=posy;
		DragDrop.oldZIndex=elem.style.zIndex;
		if(!elem.droppables){ return false; }
		elem.style.zIndex=10000;
		elem.droppables.each(function(droppable){
			droppable.addClassName("droppable");
			droppable.leftEdge=droppable.cumulativeOffset().left;
			droppable.rightEdge=droppable.leftEdge+droppable.getWidth();
			droppable.topEdge=droppable.cumulativeOffset().top;
			droppable.bottomEdge=droppable.topEdge+droppable.getHeight();
		});
		document.body.focus();
		DragDrop.mouseMove(e);
		document.onselectstart=function(){ return false; }; //IE: Don't select text
		elem.ondragstart = function(){ return false; }; //IE: Don't drag images
		return false; //Non-IE: don't select text
	},
	
	mouseMove:function(e){
		if(!DragDrop.dragging || !DragDrop.draggedElement){
			return;
		}
		if(null==e){ e=window.event; }
		var elem=e.target;
		if(null==elem){ elem=e.srcElement; }
		var de=DragDrop.draggedElement;
		de.style.left=(DragDrop.offsetX + e.clientX - DragDrop.startX)+"px";
		de.style.top =(DragDrop.offsetY + e.clientY - DragDrop.startY)+"px";
		$$(".droppable").each(function(droppable){
			if(droppable.leftEdge<e.clientX && droppable.rightEdge>e.clientX && droppable.topEdge<e.clientY && droppable.bottomEdge>e.clientY){
				droppable.addClassName("activedroppable");
				DragDrop.activeDroppable=droppable;
			} else {
				droppable.removeClassName("activedroppable");
			}
		});
		document.body.focus();
		document.onselectstart=function(){ return false; }; //IE: Don't select text
		elem.ondragstart = function(){ return false; }; //IE: Don't drag images
		return false; //Non-IE: don't select text
	},
	
	mouseUp:function(e){
		if(!DragDrop.dragging || !DragDrop.draggedElement){
			return;
		}
		if(null==e){ e=window.event; }
		var elem=e.target;
		if(null==elem){ elem=e.srcElement; }
		DragDrop.endX=e.clientX;
		DragDrop.endY=e.clientY;
		if(!DragDrop.activeDroppable){
			DragDrop.abortDrop();
			return false;
		}
		$$(".droppable").each(function(droppable){
			droppable.removeClassName("droppable");
			droppable.removeClassName("activedroppable");
		});
		
		window.setTimeout(function(){ DragDrop.draggedElement.dragDoneCallback(DragDrop.draggedElement, DragDrop.activeDroppable); DragDrop.finishDrop(); },50);
		DragDrop.draggedElement.style.zIndex=DragDrop.oldZIndex;
	},

	abortDrop:function(){
		$$(".droppable").each(function(droppable){
			droppable.removeClassName("droppable");
			droppable.removeClassName("activedroppable");
		});
		var dragged=DragDrop.draggedElement;
		dragged.style.left=(DragDrop.offsetX)+"px";
		dragged.style.top =(DragDrop.offsetY)+"px";
		dragged.offsetX=DragDrop.offsetX;
		dragged.offsetY=DragDrop.offsetY;
		if(dragged.oldParent){
			if(dragged.oldNextSibling){
				dragged.oldNextSibling.insert({ before:dragged.remove() });
			} else {
				dragged.oldParent.insert({ bottom:dragged.remove() });
			}
			if(dragged.dataset.wasrelative){
				dragged.relativize();
			}
		}
		DragDrop.dragging=false;
		DragDrop.draggedElement.removeClassName("dragging");
		if(dragged.dragAbortedCallback){
			dragged.dragAbortedCallback(dragged);
		}
		DragDrop.draggedElement=null;
		DragDrop.activeDroppable=null;
		return;
	},
	
	defaultOnDrop:function(){
		DragDrop.draggedElement.style.top=0;
		DragDrop.draggedElement.style.left=0;
		DragDrop.activeDroppable.insert({ "bottom":DragDrop.draggedElement.remove() });
	},
	
	finishDrop:function(){
		DragDrop.dragging=false;
		DragDrop.draggedElement.removeClassName("dragging");
		DragDrop.draggedElement=null;
		DragDrop.activeDroppable=null;
	}

};

/*********************************************
 * AJAX utilities
 *********************************************/


var AjaxUtils={

	//call this as the first line of any onSuccess handler. 
	checkResponse:function(transport){
		try {
			var json=JSON.parse(transport.responseText);
			if(json.notLoggedIn){
				document.location.href='/Login';
				return false;
			} else if(json.error){ 
				alert(json.error);
				return false; 
			}
		} catch(err) {
			//transport.status===0 is likely "request cancelled", e.g., page reload fired while
			//request was in progress (Chrome does this)
			if(0!==transport.status){
				alert("Something went wrong. The server said:\n\n"+transport.responseText);
			}
			return false;
		}
		return true;
	},
	
	/**
	 * Whether a previous request has failed the browser's cross-origin check. If true, the remote service does not
	 * send an Access-Control-Allow-Origin header allowing us to use it through AJAX, and we need to use the Icebear
	 * server as a proxy.
	 */
	remoteAjaxNeedsProxy:false,

	/**
	 * Submits the AJAX request to the remote server. If this request fails the cross-origin check, or a previous 
	 * request has failed it, the request is forwarded to remoteAjaxWithProxy. Note that this does not distinguish
	 * between domains: If one request from a given Icebear page fails CORS, all subsequent requests will be routed
	 * via the Icebear proxy regardless of whether they are for the domain that failed.
	 */
	remoteAjax:function(uri, method, parameters, onSuccess, onFailure, headers){
		if(AjaxUtils.remoteAjaxNeedsProxy){
			AjaxUtils.remoteAjaxWithProxy(uri, method, parameters, onSuccess, onFailure, headers);
			return;
		}
		var request={
			method:method,
			onSuccess:function(transport){
				if(0==transport.status){
					AjaxUtils.remoteAjaxNeedsProxy=true;
					AjaxUtils.remoteAjaxWithProxy(uri, method, parameters, onSuccess, onFailure, headers);
					return false;
				}
				onSuccess(transport);
			},
			onFailure:function(transport){
				if(0==transport.status){
					AjaxUtils.remoteAjaxNeedsProxy=true;
					AjaxUtils.remoteAjaxWithProxy(uri, method, parameters, onSuccess, onFailure, headers);
					return false;
				}
				onFailure(transport);
			},
		};
		if("object"==(typeof parameters).toLowerCase()){
			request.parameters=parameters;
		} else {
			request.postBody=parameters;
		}
		if(headers){
			request.requestHeaders=headers;
		}
		new Ajax.Request(uri, request);
	},
	
	/**
	 * Submits an AJAX request to Icebear, which will forward it to the supplied URI if the user is logged into 
	 * Icebear. This is to bypass CORS restrictions in browsers under controlled circumstances.
	 * see remoteAjax above.
	 */
	remoteAjaxWithProxy:function(uri, method, parameters, onSuccess, onFailure, headers){
		if(!parameters){ parameters=new Object(); }
		parameters['url']=uri;
		var request={
			method:method,
			onSuccess:function(transport){
				if(!transport.responseJSON){
					transport.responseJSON=JSON.parse(transport.responseText);
				}
				onSuccess(transport);
			},
			onFailure:function(transport){
				if(!transport.responseJSON){
					transport.responseJSON=JSON.parse(transport.responseText);
				}
				onFailure(transport);
			}
		};
		if("object"==(typeof parameters).toLowerCase()){
			request.parameters=parameters;
			if("get"!=method.toLowerCase()){
				parameters['csrfToken']=csrfToken;
				parameters['url']=uri;
			}
		} else {
			var params={};
			if("get"!=method.toLowerCase()){
				params['csrfToken']=csrfToken;
				params['rawPostBody']=parameters;
			}
			params['url']=uri;
			request.parameters=params;
		}
		if(headers){
//			Object.keys(headers).each(function(h){
//				headers['X-ICEBEARCORSPROXY-'+h]=headers[h];
//				headers[h]=null;
//			});
			request.requestHeaders=headers;
		}
		new Ajax.Request('/api/corsproxy/',request);
	},

	
		
}


var Cookies= {
		
		set:function(cname, cvalue, exdays) {
			if(!exdays){ exdays=180; }
		    var d = new Date();
		    d.setTime(d.getTime() + (exdays*24*60*60*1000));
		    var expires = "expires="+d.toUTCString();
		    document.cookie = cname + "=" + cvalue + "; " + expires;
		},
		
		get:function(cname) {
		    var name = cname + "=";
		    var ca = document.cookie.split(';');
		    for(var i=0; i<ca.length; i++) {
		        var c = ca[i];
		        while (c.charAt(0)==' ') c = c.substring(1);
		        if (c.indexOf(name) == 0) return c.substring(name.length,c.length);
		    }
		    return null;
		}
}

var UserConfig={
		
		items:{},
		
		get:function(name, defaultValue){
			if(!userId){ return defaultValue; }
			if(!UserConfig.items[name]){
				UserConfig.items[name]=defaultValue;
				window.setTimeout(function(){ UserConfig.set(name, defaultValue); }, 50);
				return defaultValue;
			}
			return UserConfig.items[name];
		},
		
		set:function(name, newValue){
			UserConfig.items[name]=newValue;
			new Ajax.Request('/api/userconfig/'+name,{
				method:'patch',
				postBody:'csrfToken='+csrfToken+'&'+name+'='+newValue
			});
		},

}


var Login={

		 doLogin: function(){
			var box=$("loginbox");
			var username=$('username').value;
			var password=$('password').value;
			/* DISABLE RFID LOGIN - 20180319
			if(username.match(rfid) && ""==password){
				$("username").blur();
				box.rfid=username;
				$("username").value="";
				$("username").focus();
				doRfidLogin();
				return;
			}
			*/
			if(""==username || ""==password){
				box.down("h2").innerHTML="Username and password required";
				return false;
			}
			box.down("input[type=submit]").up("label").addClassName("updating");
			if(box.rfid){
				Login.doRfidRegister();
				return;
			}
			new Ajax.Request('/api/Login',{
				method:'post',
				parameters:{
					username:username,
					password:password,
				},
				onSuccess:Login.doLogin_onSuccess,
				onFailure:Login.doLogin_onFailure
			});
			return false; //don't submit the form as well.
		},
		doLogin_onSuccess: function(transport){
			if(!codeAndDbMatch){
				var isAdmin=1*transport.responseJSON.isadmin;
				if(!isAdmin){
					transport.responseJSON.error=("That account is not an administrator");
					return Login.doLogin_onFailure(transport);
				}
				requestedUri="/config/#version";
			}
			if(""==requestedUri){ requestedUri="/"; }
			document.location=requestedUri;
		},
		doLogin_onFailure: function(transport){
			$("loginbox").down(".updating").removeClassName("updating");
			if(transport.responseJSON && transport.responseJSON.error){
				$("loginbox").down("h2").innerHTML=transport.responseJSON.error;
			} else {
				alert("There was an error\n\n"+transport.responseText);
			}
		},

		doRfidLogin: function(){
			var box=$("loginbox");
			if(8>$('username').value.length){
				window.setTimeout(Login.doRfidLogin, 100);
				return;
			}
			box.down("input[type=submit]").up("label").addClassName("updating");
			$('username').value="";
			$('password').value="";
			new Ajax.Request('/api/Login',{
				method:'post',
				parameters:{
					rfid:box.rfid,
				},
				onSuccess:Login.doRfidLogin_onSuccess,
				onFailure:Login.doRfidLogin_onFailure
			});
			return false; //don't submit the form as well.
		},
		doRfidLogin_onSuccess: function(transport){
			Login.doLogin_onSuccess(transport);
		},
		doRfidLogin_onFailure: function(transport){
			alert("!!!")
			$("loginbox").down(".updating").removeClassName("updating");
			if(401==transport.status && transport.responseJSON && transport.responseJSON.error){
				$("loginbox").down("h2").innerHTML='Card not known. Sign in to register it.';
			} else {
				alert("There was an error\n\n"+transport.responseText);
			}
		},

		doRfidRegister: function(){
			var box=$("loginbox");
			var username=$('username').value;
			var password=$('password').value;
			var rfid=box.rfid;
			box.down("input[type=submit]").up("label").addClassName("updating");
			$('username').value="";
			$('password').value="";
			new Ajax.Request('/api/Login',{
				method:'post',
				parameters:{
					username:username,
					password:password,
					rfid:rfid,
				},
				onSuccess:Login.doRfidRegister_onSuccess,
				onFailure:Login.doLogin_onFailure
			});
			return false; //don't submit the form as well.
		},
		doRfidRegister_onSuccess: function(transport){
			$("loginbox").rfid=null;
			$("loginbox").down(".updating").removeClassName("updating");
			$("loginbox").down("h2").innerHTML="Now touch your card again to log in";
			window.setTimeout(function(){ $("username").focus(); },50);
		},
		doRfidLogin_onFailure: function(transport){
			$("loginbox").down(".updating").removeClassName("updating");
			if(401==transport.status && transport.responseJSON && transport.responseJSON.error){
				$("rfidbox_body").innerHTML='<p>'+transport.responseJSON.error+'</p>';
				window.setTimeout(function(){ $("username").focus(); },50);
			} else {
				alert("There was an error\n\n"+transport.responseText);
			}
			
		},

		maskRfidLogin: function(){
			var field=$("username");
			if(field.value.match(rfid)){
				field.type="password";
			} else {
				field.type="text";
			}
		},
		
		logOut: function(){
			if(!confirm("Really log out?")){ return false; }
			new Ajax.Request("/api/Logout",{
				method:'post',
				onSuccess:function(){ document.location.reload(); },
				onFailure:function(transport){
					var msg="The server reported an error.";
					if(transport.responseJSON && transport.responseJSON.error){
						msg+="\n\n"+transport.responseJSON.error;
					}
					alert(msg);
					document.location.reload(); 
				}
			});
		},
						
}